#
# spec file for package dhcpcd (Version 1.3.20pl0)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip kbd less libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         dhcpcd
Version:      1.3.20pl0
Release:      26
Summary:      A DHCP client daemon
URL:          http://www.phystech.com/download/dhcpcd.html
Copyright:    GPL
Group:        Networking/Daemons
Provides:     dhcp_client dhcpcd
Conflicts:    dhclient
Requires:     net-tools
Autoreqprov:  on
Source:       ftp://ftp.phystech.com/pub/dhcpcd-%{version}.tar.bz2
Source2:      rc.dhclient
Source3:      dhcpcd-eth0.exe.SuSE
Source4:      rc.config.d.dhcpcd
Source5:      README.SuSE.dhcpcd
## This patch:
## - adds token ring support
## - fixes missing include
Patch:        dhcpcd-1.3.19pl8.dif
## This patch lets dhcpcd use modify_resolvconf(8) and adds a KeepSearchlist option (-S)
Patch1:       dhcpcd-1.3.20pl0.resolv.conf.dif
## request more options (and write the data to %{localstatedir}/dhcpcd-*-info)
Patch2:       more-options.dif
BuildRoot:    %{_tmppath}/%{name}-root
%define localstatedir /var/lib/dhcpcd/

%description
dhcpcd gets an IP address and other information from a corresponding
DHCP server, configures the network interface automatically, and tries
to renew the lease time depending on the command line option.

Authors:
--------
    Sergei Viznyuk <sv@phystech.com>
    Yoichi Hariguchi <yoichi@fore.com>

SuSE series: n

%prep
%setup -n dhcpcd-%{version}
%patch
%patch1 -p1
%patch2 -p1 
cp %{SOURCE2} %{SOURCE3} %{SOURCE4} %{SOURCE5} .
for i in README dhcpcd.8 pathnames.h; do
	cp -p $i $i.orig
	sed 's@/etc/dhcpc/\(.*\.exe\)@/sbin/\1@; s@/etc/dhcpc/\(.*\.cache\)@%{localstatedir}\1@; s@/etc/dhcpc@%{localstatedir}\1@' $i.orig > $i.t
	diff -u $i.orig $i.t || mv $i.t $i
done

%build
./configure --prefix=/usr \
		--sbindir=/sbin \
		--mandir=%{_mandir}
# add -DDEBUG to the cflags to compile a dhcpcd that does not fork and shows lots of debugging info
# use LDFLAGS="" to avoid stripping of the binary
make CFLAGS="$RPM_OPT_FLAGS -Wall"

%install
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
# next line: change etc to sbin when building for 7.0 or earlier
mkdir -p $RPM_BUILD_ROOT/etc/init.d 
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/var/adm/fillup-templates
mkdir -p $RPM_BUILD_ROOT/%{localstatedir}
make DESTDIR=$RPM_BUILD_ROOT install
# next line: change etc to sbin when building for 7.0 or earlier
install -m 744 %{SOURCE2} $RPM_BUILD_ROOT/etc/init.d/dhclient 
# uncomment these to build for 7.0 or earlier
#mkdir -p $RPM_BUILD_ROOT/sbin/init.d/rc2.d
#mkdir -p $RPM_BUILD_ROOT/sbin/init.d/rc3.d
#ln -sf ../dhclient $RPM_BUILD_ROOT/sbin/init.d/rc2.d/S05dhclient
#ln -sf ../dhclient $RPM_BUILD_ROOT/sbin/init.d/rc2.d/K40dhclient
#ln -sf ../dhclient $RPM_BUILD_ROOT/sbin/init.d/rc3.d/S05dhclient
#ln -sf ../dhclient $RPM_BUILD_ROOT/sbin/init.d/rc3.d/K40dhclient
ln -sf ../../etc/init.d/dhclient $RPM_BUILD_ROOT/sbin/rcdhclient
install -m 644 rc.config.d.dhcpcd $RPM_BUILD_ROOT/var/adm/fillup-templates/rc.config.d.dhcpcd
#install -o root -g root -m 755 dhcpcd-eth0.exe.SuSE  $RPM_BUILD_ROOT/sbin/dhcpcd-eth0.exe
#ln -s dhcpcd-eth0.exe.SuSE  $RPM_BUILD_ROOT/sbin/dhcpcd-eth1.exe
cp -p $RPM_SOURCE_DIR/README.SuSE.dhcpcd README.SuSE

%post
echo "Updating etc/rc.config and etc/rc.config.d/dhcpcd.rc.config..."
if [ -x bin/fillup ] ; then
  if ! [ -d etc/rc.config.d ] ; then
     mkdir -p etc/rc.config.d
  fi
  if ! [ -f etc/rc.config.d/dhcpcd.rc.config ] ; then
     bin/fillup -q -r -i etc/rc.config \
            var/adm/fillup-templates/rc.config.d.dhcpcd \
            etc/rc.config.d/dhcpcd.rc.config
     test -s etc/rc.config.new && mv etc/rc.config.new etc/rc.config
  else
     bin/fillup -q etc/rc.config.d/dhcpcd.rc.config \
            var/adm/fillup-templates/rc.config.d.dhcpcd
  fi
  echo "Done."
else
  echo "ERROR: fillup not found. This should not happen. Please compare"
  echo "etc/rc.config, etc/rc.config.d/dhcpcd.rc.config and"
  echo "var/adm/fillup-templates/rc.config.d.dhcpcd and update by hand."
fi
if [ -x sbin/insserv ] ; then
        # LSB: Create symbolic run level links (7.1 or later)
        sbin/insserv etc/init.d/dhclient
fi

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING INSTALL NEWS README dhcpcd-eth0.exe 
%doc README.SuSE dhcpcd-eth0.exe.SuSE
%doc %{_mandir}/man8/dhcpcd.8.gz
/sbin/dhcpcd
#%config /sbin/dhcpcd-eth0.exe
#%config /sbin/dhcpcd-eth1.exe
# next line: change etc to sbin when building for 7.0 or earlier
%config /etc/init.d/dhclient 
/sbin/rcdhclient
# uncomment these to build for 7.0 or earlier
#/sbin/init.d/rc2.d/K40dhclient
#/sbin/init.d/rc2.d/S05dhclient
#/sbin/init.d/rc3.d/K40dhclient
#/sbin/init.d/rc3.d/S05dhclient
%dir %{localstatedir}
/var/adm/fillup-templates/rc.config.d.dhcpcd

%postun
if [ -x sbin/insserv ] ; then
        # LSB: Rearrange symbolic run level links (7.1 or later)
        sbin/insserv etc/init.d/
fi

%changelog -n dhcpcd
* Tue Sep 04 2001 - poeml@suse.de
- fix a possible segfault when the DHCP server doesn't give a
  domain-name option (thanks to Nico Lumma who helped me to track
  this down)
- make sure that OldSearchList is initialized
* Tue Aug 28 2001 - poeml@suse.de
- update to 1.3.20pl0 (the single change is the removement of 0x0
  from ClientID and ClassID options)
- use the modify_resolvconf tool for all resolv.conf modifications
- fix -S option to avoid double entries in the searchlist
- report to syslog only if running in debug mode (we would clobber
  the screen at boot time because syslogd is started later)
- add dhcpcd.rc.config variables for -I (client identifier) and -h
  (hostname option) options (some ISPs require these options;
  typically, they are needed with cable modems)
- also request the options sohoServer (option 200), lprServer and
  logServer (sohoServer is used to recognize a SuSE SOHO dhcp
  server) and write those data to /var/lib/dhcpcd/dhcpcd*info
- rc.dhclient:
  * decrease startproc timeout if we are not called at boot time
  * restart target: give modify_resolvconf some time to complete
- rename localstatedir from /var/state/dhcp to /var/lib/dhcpcd to
  comply with FHS 2.1 (now the path corrections are done with 'sed'
  instead of patching the sources)
- actually use the RPM_OPT_FLAGS
- rename README.SuSE to README.SuSE.dhcpcd and update it
* Fri May 11 2001 - poeml@suse.de
- if resolv.conf does not exist, touch it; so that there is a file
  to back up and restore later and the temporary resolv.conf would
  not persist after stopping the client [#8078]
- use the modify_resolvconf tool to cleanup old backup files before
  starting the daemon, because it does it intelligently [#8077]
- don't send DHCPRELEASE by default when stopping (to avoid error
  messages when the interface has already disappeared [#8019])
* Sun Apr 15 2001 - poeml@suse.de
- don't KeepSearchlist if there is no resolv.conf (fixes a bug
  where garbage was appended)
- set the default for KeepSearchlist to "no"
- start script:
- get try-restart (meaning "restart when running") right
- replace meaningless ${2+"$2"} with $2
- fix probe section to take the correct pid file(s)
- update info header for resolv.conf acc. to guidelines
* Thu Apr 12 2001 - poeml@suse.de
- fix start script [#6961] (-D and -H were mixed up)
* Mon Apr 09 2001 - poeml@suse.de
- don't use of rc_status with -u (option was dropped)
- move rcdhclient link from /usr/sbin/ to /sbin, since the binary
  is also there
* Thu Apr 05 2001 - poeml@suse.de
- update to 1.3.19pl9 (fixes a bug which resulted in 7-byte long
  MAC address with 0x0 at the end)
- fix Version tag
* Wed Mar 28 2001 - poeml@suse.de
- update to 1.3.19pl8
- add -S switch to keep searchlist when resolv.conf is replaced
- change backup name of resolv.conf and write info header to the
  new one
- drop res_init() patch because it is included in pl8
- fix missing includes
- rework init script:
  * adhere to LSB, use /etc/rc.status
  * move variables to /etc/rc.config.d/
  * make more stuff configurable
- bzipped sources
* Wed Jan 24 2001 - poeml@suse.de
- update to 1.3.19pl6
- dhcpcd-<interface>.exe scripts, to be called by dhcpcd, are
  expected in /usr/sbin now, no longer in /var/state
- added a README.SuSE explaining the SuSE changes to the package
- the configuration has improved, so some patches are no longer
  necessary
* Mon Jan 15 2001 - poeml@suse.de
- added patch to write resolv.conf and call res_init() before
  resolving the hostname (fixes bug #4526)
- added comments on how to build for different runlevel scheme in 7.0 or
  earlier
- insert missing "" in Nov 17 patch for configure script
* Thu Jan 11 2001 - poeml@suse.de
- fix path in comment (/sbin/init.d -> /etc/init.d)
* Tue Nov 28 2000 - poeml@suse.de
- moved init script to /etc/init.d
- create links via insserv
- extracted source files from the patch to separate files
- cleaned up spec file
* Fri Nov 17 2000 - poeml@suse.de
- fixed spec file to remove stale config.cache
- fixed configure script to make testing for 2.0.x kernel work
* Fri Nov 17 2000 - kukuk@suse.de
- Fix Requires
* Thu Oct 19 2000 - grimmer@suse.de
- Update to 1.3.19pl2 (Bugfix: don't use nisDomainName in
  /etc/resolv.conf)
* Mon Aug 07 2000 - grimmer@suse.de
- Update to 1.3.19p1 (bugfix for dhcpStop function, see ChangeLog)
* Mon Aug 07 2000 - grimmer@suse.de
- Update to 1.3.19p0 (Andreas Schwab's IA64 patch now officially
  included, uncommented ioctl call in dhcpStop to prevent interface
  from having an invalid IP address during DHCP negotiation,
  dhcpcd is now libc5 and glibc compatible)
- added sample script dhcpcd-eth0.exe.SuSE from Pieter Hollants
  <Pieter.Hollants@suse.de>
- Reworked rc.config comments
* Thu Jul 13 2000 - zoz@suse.de
- changed test for availability of device: now using ifconfig, so
  automatically loading of modules will be triggered (Bug 3415)
* Tue Jul 11 2000 - zoz@suse.de
- reworked /sbin/init.d/dhclient once again due to problems with
  PCMCIA devices.
- added DHCLIENT_SET_HOSTNAME (default =no) to rc.config and
  /sbin/init.d/dhclient. (same as in package dhclient)
* Thu Jul 06 2000 - zoz@suse.de
- removed a lost and lonly "fi" from rcdhclient (Bug 3208)
* Tue Jul 04 2000 - zoz@suse.de
- changed /sbin/init.d/dhclient:
- It now starts without "DHCLIENT".
  Just setting IFCONFIG_x with NETCONFIG contains _x is enough.
- It does not stop the demon, if it was set up by pcmcia-scripts
  but writes a message what to do then.
- changed rc.config.dhclient: removed "DHCLIENT", but left the
  comment.
* Fri Jun 16 2000 - grimmer@suse.de
- Update to dhcpcd-1.3.18-pl8 (new -T flag to go through normal
  DHCP negotiation sequence without configuring the interface or
  otherwise change anything on the system, fix possible problem
  in retransmitting DHCP requests, and make dhcpcd adapt to
  possible change in DHCP server address in the middle of a
  client's lease, new -C option to perform checksum on received
  packets, now set dhcpcd's process umask to 022 before creating
  /etc/resolv.confi, new -n flag to force currently running
  dhcpcd to try to renew the lease)
- now uses GNU autoconf and automake
- added Red Hat's Token Ring patch and submitted it to author
- added BuildRoot and RPM macros
- added /sbin/icmprequest to file list
- added more docu to file list
* Tue Mar 28 2000 - grimmer@suse.de
- Update to dhcpcd-1.3.18-pl5 (reverse lookup patch is now
  officially included)
- removed our (now obsolete) patch
* Mon Mar 27 2000 - grimmer@suse.de
- Update to dhcpcd-1.3.18-pl4 (minor fixes)
* Mon Mar 13 2000 - grimmer@suse.de
- reverted init script to original behaviour since automatic
  setting of host name is not always desirable (e.g. X11)
* Sun Mar 12 2000 - bk@suse.de
- added reverse lookup for sethostname; if -H option is given
  and dhcpcd didn't get a hostname from the dhcp server.
- Olaf added silent startup of dhcpcd.
* Sun Mar 12 2000 - grimmer@suse.de
- added Option -D -H (set domain- and hostname) to init script
* Fri Feb 18 2000 - grimmer@suse.de
- added Option -d (for logging via syslog) to init script
* Thu Jan 27 2000 - grimmer@suse.de
- initial version (1.3.18-pl3)
- changed man path to /usr/share/man
- adjusted path for leases from /etc/dhcpc to /var/state/dhcp
- created init script (compatible with dhclient) and variables
  for /etc/rc.config
